import Sequelize from "@golemio/core/dist/shared/sequelize";

export const outputTrafficInfoSchema = {
    type: "array",
    items: {
        type: "object",
        required: [
            "situation_id",
            "situation_version",
            "situation_record_version",
            "situation_record_type",
            "situation_record_creation_time",
            "situation_record_version_time",
        ],
        additionalProperties: false,
        properties: {
            exchange: { type: "object" },
            publication_time: { type: "string" },
            publication_creator: { type: "object" },
            situation_id: { type: "string" },
            situation_version: { type: "string" },
            situation_version_time: { type: "string" },
            situation_confidentiality: { type: "string" },
            situation_information_status: { type: "string" },
            situation_urgency: { type: "string" },
            situation_record_version: { type: "string" },
            situation_record_type: { type: "string" },
            situation_record_creation_time: { type: "string" },
            situation_record_version_time: { type: "string" },
            probability_of_occurrence: { type: "string" },
            source: { type: "string" },
            validity_status: { type: "string" },
            validity_overall_start_time: { type: "string" },
            validity_overall_end_time: { type: "string" },
            impact_capacity_remaining: { type: "number" },
            impact_number_of_lanes_restricted: { type: "number" },
            impact_number_of_operational_lanes: { type: "number" },
            impact_original_number_of_lanes: { type: "number" },
            impact_traffic_constriction_type: { type: "string" },
            impact_delays_type: { type: "string" },
            impact_delay_time_value: { type: "number" },
            cause: { type: "object" },
            general_public_comment: { type: "string" },
            group_of_locations_type: { type: "string" },
            supplementary_positional_description: { type: "object" },
            destination: { type: "object" },
            alert_c_linear: { type: "object" },
            linear_within_linear_element: { type: "object" },
            global_network_linear: { type: "object" },
            linear_extension: { type: "object" },
            situation_record_extension: { type: "object" },
            number_of_obstructions: { type: "number" },
            mobility_of_obstruction: { type: "object" },
            compliance_option: { type: "string" },
            applicable_for_traffic_direction: { type: "string" },
            applicable_for_traffic_type: { type: "string" },
            places_at_which_applicable: { type: "string" },
            for_vehicles_with_characteristics_of: { type: "object" },
            roadworks_duration: { type: "string" },
            roadworks_scale: { type: "string" },
            under_traffic: { type: "boolean" },
            urgent_roadworks: { type: "boolean" },
            mobility: { type: "object" },
            subjects: { type: "object" },
            maintenance_vehicles: { type: "object" },
            abnormal_traffic_type: { type: "string" },
            relative_traffic_flow: { type: "string" },
            traffic_trend_type: { type: "string" },
            accident_type: { type: "string" },
            total_number_of_vehicles_involved: { type: "number" },
            vehicle_involved: { type: "object" },
            group_of_vehicles_involved: { type: "object" },
            group_of_people_involved: { type: "object" },
            animal_presence_type: { type: "string" },
            alive: { type: "boolean" },
            authority_operation_type: { type: "string" },
            car_park_configuration: { type: "string" },
            car_park_identity: { type: "string" },
            car_park_occupancy: { type: "string" },
            car_park_status: { type: "string" },
            number_of_vacant_parking_spaces: { type: "number" },
            occupied_spaces: { type: "number" },
            total_capacity: { type: "number" },
            driving_condition_type: { type: "string" },
            construction_work_type: { type: "string" },
            disturbance_activity_type: { type: "string" },
            depth: { type: "number" },
            environmental_obstruction_type: { type: "string" },
            equipment_or_system_fault_type: { type: "string" },
            faulty_equipment_or_system_type: { type: "string" },
            general_instruction_to_road_users_type: { type: "string" },
            general_message_to_road_users: { type: "object" },
            general_network_management_type: { type: "string" },
            traffic_manually_directed_by: { type: "string" },
            obstruction_type: { type: "string" },
            infrastructure_damage_type: { type: "string" },
            road_maintenance_type: { type: "string" },
            non_weather_related_road_condition_type: { type: "string" },
            poor_environment_type: { type: "string" },
            precipitation_detail: { type: "object" },
            visibility: { type: "object" },
            temperature: { type: "object" },
            wind: { type: "object" },
            public_event_type: { type: "string" },
            rerouting_management_type: { type: "string" },
            rerouting_itinerary_description: { type: "object" },
            signed_rerouting: { type: "boolean" },
            entry: { type: "string" },
            exit: { type: "string" },
            road_or_junction_number: { type: "string" },
            road_operator_service_disruption_type: { type: "string" },
            road_or_carriageway_or_lane_management_type: { type: "string" },
            minimum_car_occupancy: { type: "number" },
            roadside_assistance_type: { type: "string" },
            roadside_service_disruption_type: { type: "string" },
            speed_management_type: { type: "string" },
            temporary_speed_limit: { type: "number" },
            transit_service_information: { type: "string" },
            transit_service_type: { type: "string" },
            vehicle_obstruction_type: { type: "string" },
            obstructing_vehicle: { type: "object" },
            weather_related_road_condition_type: { type: "string" },
            road_surface_condition_measurements: { type: "object" },
            winter_equipment_management_type: { type: "string" },
            alert_c_direction: { type: "string" },
            geom_openlr_line: { type: "object" },
            geom_gn_line: { type: "object" },
            geom_alert_c_line: { type: "object" },
        },
    },
};

export const outputTrafficInfoSDMA: Sequelize.ModelAttributes<any> = {
    exchange: { type: Sequelize.JSON },
    publication_time: { type: Sequelize.DATE },
    publication_creator: { type: Sequelize.JSON },
    situation_id: {
        primaryKey: true,
        allowNull: false,
        type: Sequelize.STRING(100),
    },
    situation_version: {
        primaryKey: true,
        type: Sequelize.STRING(100),
    },
    situation_version_time: { type: Sequelize.DATE },
    situation_confidentiality: { type: Sequelize.STRING(100) },
    situation_information_status: { type: Sequelize.STRING(100) },
    situation_urgency: { type: Sequelize.STRING(100) },
    situation_record_version: {
        allowNull: false,
        type: Sequelize.STRING(100),
    },
    situation_record_type: {
        primaryKey: true,
        allowNull: false,
        type: Sequelize.STRING(100),
    },
    situation_record_creation_time: {
        allowNull: false,
        type: Sequelize.DATE,
    },
    situation_record_version_time: {
        primaryKey: true,
        allowNull: false,
        type: Sequelize.DATE,
    },
    probability_of_occurrence: { type: Sequelize.STRING(100) },
    source: { type: Sequelize.STRING(100) },
    validity_status: { type: Sequelize.STRING(100) },
    validity_overall_start_time: { type: Sequelize.DATE },
    validity_overall_end_time: { type: Sequelize.DATE },
    impact_capacity_remaining: { type: Sequelize.REAL },
    impact_number_of_lanes_restricted: { type: Sequelize.INTEGER },
    impact_number_of_operational_lanes: { type: Sequelize.INTEGER },
    impact_original_number_of_lanes: { type: Sequelize.INTEGER },
    impact_traffic_constriction_type: { type: Sequelize.STRING(100) },
    impact_delays_type: { type: Sequelize.STRING(100) },
    impact_delay_time_value: { type: Sequelize.REAL },
    cause: { type: Sequelize.JSON },
    general_public_comment: { type: Sequelize.TEXT },
    group_of_locations_type: { type: Sequelize.STRING(100) },
    supplementary_positional_description: { type: Sequelize.JSON },
    destination: { type: Sequelize.JSON },
    alert_c_linear: { type: Sequelize.JSON },
    linear_within_linear_element: { type: Sequelize.JSON },
    global_network_linear: { type: Sequelize.JSON },
    linear_extension: { type: Sequelize.JSON },
    situation_record_extension: { type: Sequelize.JSON },
    number_of_obstructions: { type: Sequelize.INTEGER },
    mobility_of_obstruction: { type: Sequelize.JSON },
    compliance_option: { type: Sequelize.STRING(100) },
    applicable_for_traffic_direction: { type: Sequelize.STRING(100) },
    applicable_for_traffic_type: { type: Sequelize.STRING(100) },
    places_at_which_applicable: { type: Sequelize.STRING(100) },
    for_vehicles_with_characteristics_of: { type: Sequelize.JSON },
    roadworks_duration: { type: Sequelize.STRING(100) },
    roadworks_scale: { type: Sequelize.STRING(100) },
    under_traffic: { type: Sequelize.BOOLEAN },
    urgent_roadworks: { type: Sequelize.BOOLEAN },
    mobility: { type: Sequelize.JSON },
    subjects: { type: Sequelize.JSON },
    maintenance_vehicles: { type: Sequelize.JSON },
    abnormal_traffic_type: { type: Sequelize.STRING(100) },
    relative_traffic_flow: { type: Sequelize.STRING(100) },
    traffic_trend_type: { type: Sequelize.STRING(100) },
    accident_type: { type: Sequelize.STRING(100) },
    total_number_of_vehicles_involved: { type: Sequelize.INTEGER },
    vehicle_involved: { type: Sequelize.JSON },
    group_of_vehicles_involved: { type: Sequelize.JSON },
    group_of_people_involved: { type: Sequelize.JSON },
    animal_presence_type: { type: Sequelize.STRING(100) },
    alive: { type: Sequelize.BOOLEAN },
    authority_operation_type: { type: Sequelize.STRING(100) },
    car_park_configuration: { type: Sequelize.STRING(100) },
    car_park_identity: { type: Sequelize.TEXT },
    car_park_occupancy: { type: Sequelize.STRING(100) },
    car_park_status: { type: Sequelize.STRING(100) },
    number_of_vacant_parking_spaces: { type: Sequelize.INTEGER },
    occupied_spaces: { type: Sequelize.INTEGER },
    total_capacity: { type: Sequelize.INTEGER },
    driving_condition_type: { type: Sequelize.STRING(100) },
    construction_work_type: { type: Sequelize.STRING(100) },
    disturbance_activity_type: { type: Sequelize.STRING(100) },
    depth: { type: Sequelize.REAL },
    environmental_obstruction_type: { type: Sequelize.STRING(100) },
    equipment_or_system_fault_type: { type: Sequelize.STRING(100) },
    faulty_equipment_or_system_type: { type: Sequelize.STRING(100) },
    general_instruction_to_road_users_type: { type: Sequelize.STRING(100) },
    general_message_to_road_users: { type: Sequelize.JSON },
    general_network_management_type: { type: Sequelize.STRING(100) },
    traffic_manually_directed_by: { type: Sequelize.STRING(100) },
    obstruction_type: { type: Sequelize.STRING(100) },
    infrastructure_damage_type: { type: Sequelize.STRING(100) },
    road_maintenance_type: { type: Sequelize.STRING(100) },
    non_weather_related_road_condition_type: { type: Sequelize.STRING(100) },
    poor_environment_type: { type: Sequelize.STRING(100) },
    precipitation_detail: { type: Sequelize.JSON },
    visibility: { type: Sequelize.JSON },
    temperature: { type: Sequelize.JSON },
    wind: { type: Sequelize.JSON },
    public_event_type: { type: Sequelize.STRING(100) },
    rerouting_management_type: { type: Sequelize.STRING(100) },
    rerouting_itinerary_description: { type: Sequelize.JSON },
    signed_rerouting: { type: Sequelize.BOOLEAN },
    entry: { type: Sequelize.TEXT },
    exit: { type: Sequelize.TEXT },
    road_or_junction_number: { type: Sequelize.TEXT },
    road_operator_service_disruption_type: { type: Sequelize.STRING(100) },
    road_or_carriageway_or_lane_management_type: { type: Sequelize.STRING(100) },
    minimum_car_occupancy: { type: Sequelize.INTEGER },
    roadside_assistance_type: { type: Sequelize.STRING(100) },
    roadside_service_disruption_type: { type: Sequelize.STRING(100) },
    speed_management_type: { type: Sequelize.STRING(100) },
    temporary_speed_limit: { type: Sequelize.REAL },
    transit_service_information: { type: Sequelize.STRING(100) },
    transit_service_type: { type: Sequelize.STRING(100) },
    vehicle_obstruction_type: { type: Sequelize.STRING(100) },
    obstructing_vehicle: { type: Sequelize.JSON },
    weather_related_road_condition_type: { type: Sequelize.STRING(100) },
    road_surface_condition_measurements: { type: Sequelize.JSON },
    winter_equipment_management_type: { type: Sequelize.STRING(100) },

    // Geom
    alert_c_direction: { type: Sequelize.STRING(100) },
    geom_openlr_line: { type: Sequelize.GEOMETRY },
    geom_gn_line: { type: Sequelize.GEOMETRY },
    geom_alert_c_line: { type: Sequelize.GEOMETRY },

    // ⬐ Audit fields
    create_batch_id: { type: Sequelize.BIGINT },
    created_at: { type: Sequelize.DATE },
    created_by: { type: Sequelize.STRING(150) },
    update_batch_id: { type: Sequelize.BIGINT },
    updated_at: { type: Sequelize.DATE },
    updated_by: { type: Sequelize.STRING(150) },
};
